program SUB_SAMPLE
	use sep
	use mem_mod
	use fbi_mod
	use initialize
	implicit none

	!===========================================================================
	!	Allocate and Initialize
	!---------------------------------------------------------------------------
	integer                             	:: nt, nz, nx, isou, every
	integer                             	:: sou_nx, sou_ox, sou_dx, sou_z, sou_x
	integer                             	:: rec_nx, rec_ox, rec_dx, rec_z, rec_x
	real                                	:: dt, dz, oz, dx, ox, ot
	real, dimension(:,:), allocatable		:: obsdata

	!===========================================================================
	! call init_forward(nz,nx,nt,dz,dx,dt,oz,ox,ot,sou_nx,sou_dx,sou_ox,rec_nx,rec_dx,rec_ox,rec_z)
	call sep_init()
	call from_history('n1', nt)
	call from_history('n2', rec_nx)
	call from_history('n3', sou_nx)
	call from_param("every", every)

			write(0,*) " got here 0"

	call mem_alloc2d(obsdata,nt,rec_nx)



	! if (exist_file('subsampled')) then
	! 	call to_history("n1"    ,nz			,'subsampled')
	! 	call to_history("n2"    ,nx			,'subsampled')
	! 	call to_history("n3"    ,nt			,'subsampled')  ! To account for the first frame being phi0
	! 	call to_history("d1"    ,dz			,'subsampled')
	! 	call to_history("d2"    ,dx			,'subsampled')
	! 	call to_history("d3"    ,dt			,'subsampled')
	! 	call to_history("o1"    ,oz			,'subsampled')
	! 	call to_history("o2"    ,ox			,'subsampled')
	! 	call to_history("o3"    ,ot			,'subsampled')
	! 	call to_history("label1",'z [km]'	,'subsampled')
	! 	call to_history("label2",'x [km]'	,'subsampled')
	! 	call to_history("label3",'time'		,'subsampled')
	! end if


	!---------------------------------------------------------------------------
	do isou=1, sou_nx
		write(0,*) "sou_nx = ", sou_nx
		write(0,*) "MOD(isou,every) = ", MOD(isou,every)

		if (MOD(isou,every)==0) then
			write(0,*) " got here 1"
			call sep_read(obsdata)
			call sep_write(obsdata)
		end if
	end do

			write(0,*) " got here 2"


end program
