
program TEST
	use sep
	use mem_mod
	implicit none

	!===========================================================================
	!	Allocate and Initialize
	!---------------------------------------------------------------------------
	integer									:: nz,nx
	real, dimension(:,:), allocatable		:: model
	!===========================================================================
	write(0,*) "Inside the TEST program"

	call sep_init()

	call from_history("n1",nz)
	call from_history("n2",nx)
	call mem_alloc2d(model, nz, nx)

	call sep_read(model)

	model = model*0.8*model

	call sep_write(model)
	call sep_close()

end program



