! module fbi_mod_ORIGINAL

!   use sep
!   use mem_mod
!   use tomo_mod
!   use sscale_mod
!   use lint_mod
!   use step_mod
!   use scats0_sso_mod
!   use scatr0_mod
!   use secder_mod

!   implicit none
!   integer, private                                     	:: nt, n1, n2, nt2, wfld_j, it, nth, nh
!   integer, private                                     	:: sou_nx, sou_ox, sou_dx, sou_z, isou, sou_x
!   integer, private                                     	:: rec_nx, rec_ox, rec_dx, rec_z, irec, rec_x, edge_par_shot, edge_par_rec
!   integer, private                                     	:: bc1, bc2, bc3, bc4
!   real, private                                        	:: dt, d1, o1, d2, o2, dtw
!   real, dimension(:,:), allocatable, target, private   	:: veldt2, vwt, wt !,vel, refl, !Not present in main: veldt2, vwt, wt. ! Not sure refl is necessary
!   !real, dimension(:,:,:), allocatable, private         	:: dobs
!   !real, dimension(:,:,:), allocatable, target, private :: wfldr0
!   real,dimension(:,:,:,:),allocatable, target, private  :: temp1,temp2,temp1i,temp2i, wflds0, modelb
!   real, dimension(:,:,:), allocatable, target, private 	:: datab!, insrc
! !--------------------------------------------------------------------------------------
!   real, dimension(:), allocatable		      	        :: wavelet ! This is a copy of what is in main. Could use a pointer instead if you want.

! !--------------------------------------------------------------------------------------
!   contains



! 	subroutine init1(n1_in, o1_in, d1_in, n2_in, o2_in, d2_in, bc1_in, bc2_in, bc3_in, bc4_in) ! Copying variables 1
! 		integer			:: n1_in, n2_in, bc1_in, bc2_in, bc3_in, bc4_in
! 		real			:: d1_in, o1_in, d2_in, o2_in
! 		n1 = n1_in
! 		n2 = n2_in
! 		d1 = d1_in
! 		o1 = o1_in
! 		d2 = d2_in
! 		o2 = o2_in
! 		bc1 = bc1_in
! 		bc2 = bc2_in
! 		bc3 = bc3_in
! 		bc4 = bc4_in
! 	end subroutine



! 	subroutine init2(sou_nx_in, sou_ox_in, sou_dx_in, sou_z_in, rec_nx_in, rec_ox_in, rec_dx_in, rec_z_in, edge_par_shot_in, edge_par_rec_in) ! Copying variables 2
! 		integer                             :: sou_nx_in, sou_ox_in, sou_dx_in, sou_z_in
! 		integer                             :: rec_nx_in, rec_ox_in, rec_dx_in, rec_z_in, edge_par_shot_in, edge_par_rec_in
! 		sou_nx = sou_nx_in
! 		sou_ox = sou_ox_in
! 		sou_dx = sou_dx_in
! 		sou_z = sou_z_in
! 		rec_nx = rec_nx_in
! 		rec_ox = rec_ox_in
! 		rec_dx = rec_dx_in
! 		rec_z = rec_z_in
! 		edge_par_shot = edge_par_shot_in
! 		edge_par_rec = edge_par_rec_in
! 	end subroutine



! 	subroutine init3(nt_in, dt_in, nh_in, wfld_j_in) ! Copying variables 3
! 		integer				:: nt_in, wfld_j_in, nh_in
! 		real				:: dt_in
! 		nt = nt_in
! 		nh = nh_in
! 		wfld_j = wfld_j_in
! 		dt = dt_in
! 	end subroutine



! 	subroutine init_alloc(wavelet_in) ! Allocations
! 		real, dimension(:)				:: wavelet_in 
! 		integer, external				:: omp_get_num_threads

! 		!$OMP PARALLEL
! 		! nth=omp_get_num_threads()   ! Need this for shot parallelization
! 		write(0,*) " Number of threads = ", omp_get_num_threads()
! 		!$OMP END PARALLEL

! 		nth=1
! 		write(0,*) " ALLOCATED nth= ", nth
! 		write(0,*) " ALLOCATED nh= ", nh

! 		nt2 = (nt-1)*wfld_j+1
! 		dtw = dt / wfld_j

! 		call mem_alloc2d(veldt2, n1, n2)
! 		call mem_alloc2d(vwt, n1, n2)
! 		call mem_alloc2d(wt, n1, n2)
! 		call mem_alloc4d(wflds0, n1, n2, nt,nth)
! 		!call mem_alloc3d(wfldr0, n1, n2, nt)
! 		!call mem_alloc3d(dobs, nt, rec_nx, sou_nx)
! 		call mem_alloc4d(temp1, n1, n2, nt,nth)
! 		call mem_alloc4d(temp2, n1, n2, nt,nth)
! 		call mem_alloc4d(temp1i, n1, n2, nt2,nth)
! 		call mem_alloc4d(temp2i, n1, n2, nt2,nth)
! 		! call mem_alloc4d(datab, nt, rec_nx, sou_nx,nth)
! 		call mem_alloc3d(datab, nt, rec_nx, nth)
! 		call mem_alloc4d(modelb, n1, n2, (2*nh+1), nth)
! 		call mem_alloc1d(wavelet, nt)

! 		wavelet = wavelet_in 

! 		call sscale_init(n1, n2, nt, dtw, veldt2, wt)
! 		call lint_init(n1, n2, nt, wfld_j)
! 		call step_init(n1, n2, nt2, bc1, bc2, bc3, bc4, d1, d2, veldt2, vwt, wt)
! 		call scats0_init(n1, n2, nt, nh, wflds0)
! 		!call scatr0_init(n1, n2, nt, wfldr0)
! 		call secder_init(n1, n2, nt, dt)


! ! !============================================================================

! ! 		if (exist_file('insrc' )) then
! ! 			call mem_alloc3d(insrc, n1, n2, nt)
! ! 			call sep_read(insrc, 'insrc' )
! ! 		end if

! ! !============================================================================

! 	end subroutine







! 	subroutine model_update(vel_total) ! Copy velocity model and prepare boundary condition stuff
! 		real, dimension(:,:)		:: vel_total

! 		vwt = 0.
! 		wt = 0.

! 		call AbcWt(vel_total, vwt, wt, dtw, d1, d2, bc1, bc2, bc3, bc4)
! 		veldt2 = vel_total*vel_total*dtw*dtw

! 	end subroutine










! ! !///////////////////////////////////////////////////////////////////////////////////////////////////////////////
! ! !	This version generates shot gathers for receivers that are on one side of the source (trailing)
! ! 	subroutine forward_wavefield(rec_wave, isou) ! Nonlinear operator: source => full nonlinear data (equation 9)
! ! 		integer							:: isou
! ! 		real, dimension(nt, rec_nx)		:: rec_wave
! ! 		rec_wave = 0.0
! ! 		temp1 = 0.0

! ! 	!----------------------------------------------------------
! ! 		sou_x = (isou-1)*sou_dx + sou_ox
! ! 		temp1(sou_z,sou_x,:,1) = wavelet ! K operator
! ! 		call sscale_op2(.false., .false., temp1(:,:,:,1), temp2(:,:,:,1)) ! S operator
! ! 		call lint_op2(.false., .false., temp2(:,:,:,1), temp1i(:,:,:,1)) ! L operator
! ! 		call step_op2(.false., .false., temp1i(:,:,:,1), temp2i(:,:,:,1),1) ! G operator
! ! 		call lint_op2(.true., .false., temp1(:,:,:,1), temp2i(:,:,:,1)) ! L' operator
! ! 	!----------------------------------------------------------
! ! 		do irec=1,rec_nx ! K' operator
! ! 			! rec_x = (irec-1)*rec_dx + rec_ox
! ! 			rec_x = (irec-1)*rec_dx + (sou_ox-rec_ox) + sou_x ! This is the part that makes it trailing recievers only
! ! 			! write(0,*) "rec_x =", rec_x
! ! 			rec_wave(:,irec) = rec_wave(:,irec) + temp1(rec_z,rec_x,:,1)
! ! 		end do
! ! 	!----------------------------------------------------------

! ! 		if (exist_file('temp1')) call sep_write(temp1,"temp1")

! ! 	end subroutine








! !///////////////////////////////////////////////////////////////////////////////////////////////////////////////
! !	This version generates shot gathers for receivers that are on one side of the source (trailing)
! 	subroutine forward_wavefield(src_wavefield, rec_wave, isou) ! Nonlinear operator: source => full nonlinear data (equation 9)
! 		integer							:: isou
! 		real, dimension(nt, rec_nx)		:: rec_wave
! 		real, dimension(n1, n2, nt)		:: src_wavefield

! 		rec_wave = 0.0
! 		temp1 = 0.0

! 	!----------------------------------------------------------
! 		sou_x = (isou-1)*sou_dx + sou_ox
! 		temp1(sou_z,sou_x,:,1) = wavelet ! K operator
! 		call sscale_op2(.false., .false., temp1(:,:,:,1), temp2(:,:,:,1)) ! S operator
! 		call lint_op2(.false., .false., temp2(:,:,:,1), temp1i(:,:,:,1)) ! L operator
! 		call step_op2(.false., .false., temp1i(:,:,:,1), temp2i(:,:,:,1),1) ! G operator
! 		call lint_op2(.true., .false., temp1(:,:,:,1), temp2i(:,:,:,1)) ! L' operator
! 	!----------------------------------------------------------
! 		do irec=1,rec_nx ! K' operator
! 			! rec_x = (irec-1)*rec_dx + rec_ox
! 			rec_x = (irec-1)*rec_dx + (sou_ox-rec_ox) + sou_x ! This is the part that makes it trailing recievers only
! 			! write(0,*) "rec_x =", rec_x
! 			rec_wave(:,irec) = rec_wave(:,irec) + temp1(rec_z,rec_x,:,1)
! 		end do
! 	!----------------------------------------------------------

! 		src_wavefield = temp1(:,:,:,1)
! 	end subroutine









!   subroutine L_lop2(adj, add, model, data, isou) ! Born operator: perturbation <=> First order scattered data (i.e. data due to perturbation) (equation 22)
!     logical, intent(in)						:: adj, add
!     real, dimension(n1, n2, -nh:nh)			:: model
!     real, dimension(nt, rec_nx)				:: data
!     integer									:: i, ith, isou, ih

! 	ith=1
!     if(adj) then ! Adjoint: First order scattered data => perturbation
!       if(.not. add) modelb(:,:,:,ith) = 0.

! 		! if (exist_file('insrc' )) then
! 		! 	! call scats0_init(n1, n2, nt, insrc)  ! Initialize the source wavefield
! 		! else
! 	       ! Precompute the u_s0 wavefield using the wavelet
! 	        sou_x = (isou-1)*sou_dx + sou_ox
! 	        temp1(:,:,:,ith) = 0.
! 			temp1(sou_z,sou_x,:,ith) = wavelet

! 	        call sscale_op2(.false., .false., temp1(:,:,:,ith), temp2(:,:,:,ith)) ! S operator
! 	        call lint_op2(.false., .false., temp2(:,:,:,ith), temp1i(:,:,:,ith)) ! L operator
! 	        call step_op2(.false., .false., temp1i(:,:,:,ith), temp2i(:,:,:,ith), ith) ! G operator
! 	        call lint_op2(.true., .false., wflds0(:,:,:,ith), temp2i(:,:,:,ith)) ! L' operator

! 			if (exist_file('temp1' )) call sep_write(wflds0(:,:,:,ith), 'temp1' )
! 		! end if
 

!         ! operator starts here
!         temp1(:,:,:,ith) = 0.

! 		do irec=1,rec_nx
! 			rec_x = (irec-1)*rec_dx + (sou_ox-rec_ox) + sou_x ! This is the part that makes it trailing recievers only
! 			temp1(rec_z,rec_x,:,ith) = data(:,irec)
! 		end do

!         call lint_op2(.false., .false., temp1(:,:,:,ith), temp2i(:,:,:,ith)) ! L operator
!         call step_op2(.true., .false., temp1i(:,:,:,ith), temp2i(:,:,:,ith),ith) ! G' operator
!         call lint_op2(.true., .false., temp1(:,:,:,ith), temp1i(:,:,:,ith)) ! L' operator
!         call sscale_op2(.true., .false., temp2(:,:,:,ith), temp1(:,:,:,ith)) ! S' operator
!         call secder_op2(.true., .false., temp1(:,:,:,ith), temp2(:,:,:,ith)) ! T' operator
!         call scats0_op2(.true., .true., modelb(:,:,:,ith), temp1(:,:,:,ith),ith) ! (U^_s0)' operator

! 	    ! Stack over all threads
! 		do i=1,nth
! 			model=model + modelb(:,:,:,i)
! 		end do

!     else ! Forward: perturbation => First order scattered data

!       if(.not. add) datab(:,:,ith) = 0.

!         ! Precompute the u_s0 wavefield using the wavelet
!         sou_x = (isou-1)*sou_dx + sou_ox
!         temp1(:,:,:,ith) = 0.
! 		temp1(sou_z,sou_x,:,ith) = wavelet

!         call sscale_op2(.false., .false., temp1(:,:,:,ith), temp2(:,:,:,ith)) ! S operator
!         call lint_op2(.false., .false., temp2(:,:,:,ith), temp1i(:,:,:,ith)) ! L operator
!         call step_op2(.false., .false., temp1i(:,:,:,ith), temp2i(:,:,:,ith),ith) ! G operator
!         call lint_op2(.true., .false., wflds0(:,:,:,ith), temp2i(:,:,:,ith)) ! L' operator

!         ! operator starts here
! 		modelb(:,:,:,ith)=model
!         call scats0_op2(.false., .false., modelb(:,:,:,ith), temp1(:,:,:,ith),ith) ! U^_s0 operator
!         call secder_op2(.false., .false., temp1(:,:,:,ith), temp2(:,:,:,ith)) ! T operator
!         call sscale_op2(.false., .false., temp2(:,:,:,ith), temp1(:,:,:,ith)) ! S operator
!         call lint_op2(.false., .false., temp1(:,:,:,ith), temp1i(:,:,:,ith)) ! L operator
!         call step_op2(.false., .false., temp1i(:,:,:,ith), temp2i(:,:,:,ith),ith) ! G operator
!         call lint_op2(.true., .false., temp1(:,:,:,ith), temp2i(:,:,:,ith)) ! L' operator

! 		do irec=1,rec_nx
! 			rec_x = (irec-1)*rec_dx + (sou_ox-rec_ox) + sou_x ! This is the part that makes it trailing recievers only
! 			datab(:,irec,ith) = datab(:,irec,ith) + temp1(rec_z,rec_x,:,ith)
! 		end do

! 		! Stack over all threads
! 		do i=1,nth
! 			data=data+datab(:,:,i)
! 		end do

!     end if


!   end subroutine   










! end module 
