module initialize1
  use sep
  implicit none
  contains




subroutine outfiles_Hfree()
	integer		:: nz, nx, niter
	real 		:: dz, oz, dx, ox

	!----------------------------------------------------------------------------------------------
	!call from_param("niter", niter)
	call from_param("n1", nz)
	call from_param("n2", nx)
	call from_param("o1", oz)
	call from_param("o2", ox)
	call from_param("d1", dz)
	call from_param("d2", dx)
	!----------------------------------------------------------------------------------------------

	if (exist_file('Hv')) then
   		call to_history("n1",nz, 'Hv')
   		call to_history("n2",nx, 'Hv')
		! call to_history("n3",300, 'Hv')
		call to_history("d1",dz, 'Hv')
		call to_history("d2",dx, 'Hv')
		call to_history("o1",oz, 'Hv')
		call to_history("o2",ox, 'Hv')
		call to_history("label1",'z [km]', 'Hv')
		call to_history("label2",'x [km]', 'Hv')
		! call to_history("label3",'iteration', 'Hv')
	end if


end subroutine







subroutine outfiles_serial1()
	integer		:: nz, nx, niter
	real 		:: dz, oz, dx, ox

	!----------------------------------------------------------------------------------------------
	!call from_param("niter", niter)
	call from_param("n1", nz)
	call from_param("n2", nx)
	call from_param("o1", oz)
	call from_param("o2", ox)
	call from_param("d1", dz)
	call from_param("d2", dx)
	!----------------------------------------------------------------------------------------------

	if (exist_file('vel_full')) then
   		call to_history("n1",nz, 'vel_full')
   		call to_history("n2",nx, 'vel_full')
		! call to_history("n3",300, 'vel_full')
		call to_history("d1",dz, 'vel_full')
		call to_history("d2",dx, 'vel_full')
		call to_history("o1",oz, 'vel_full')
		call to_history("o2",ox, 'vel_full')
		call to_history("label1",'z [km]', 'vel_full')
		call to_history("label2",'x [km]', 'vel_full')
		! call to_history("label3",'iteration', 'vel_full')
	end if


	! if (exist_file('vel_comp')) then
 !   		call to_history("n1",nz, 'vel_comp')
 !   		call to_history("n2",nx, 'vel_comp')
	! 	call to_history("n3",1, 'vel_comp')
	! 	call to_history("d1",dz, 'vel_comp')
	! 	call to_history("d2",dx, 'vel_comp')
	! 	call to_history("o1",oz, 'vel_comp')
	! 	call to_history("o2",ox, 'vel_comp')
	! 	call to_history("label1",'z [km]', 'vel_comp')
	! 	call to_history("label2",'x [km]', 'vel_comp')
	! 	call to_history("label3",'iteration', 'vel_comp')
	! end if

	! if (exist_file('weightsTOP1')) then
	! 	call to_history("n1",nz, 'weightsTOP1')
	! 	call to_history("n2",nx, 'weightsTOP1')
	! 	!call to_history("n3",niter, 'weightsTOP1')
	! 	call to_history("d1",dz, 'weightsTOP1')
	! 	call to_history("d2",dx, 'weightsTOP1')
	! 	call to_history("o1",oz, 'weightsTOP1')
	! 	call to_history("o2",ox, 'weightsTOP1')
	! 	call to_history("label1",'z [km]', 'weightsTOP1')
	! 	call to_history("label2",'x [km]', 'weightsTOP1')
	! 	!call to_history("label3",'iteration', 'weightsTOP1')
	! end if

	! if (exist_file('weightsBOT1')) then
	! 	call to_history("n1",nz, 'weightsBOT1')
	! 	call to_history("n2",nx, 'weightsBOT1')
	! 	!call to_history("n3",niter, 'weightsBOT1')
	! 	call to_history("d1",dz, 'weightsBOT1')
	! 	call to_history("d2",dx, 'weightsBOT1')
	! 	call to_history("o1",oz, 'weightsBOT1')
	! 	call to_history("o2",ox, 'weightsBOT1')
	! 	call to_history("label1",'z [km]', 'weightsBOT1')
	! 	call to_history("label2",'x [km]', 'weightsBOT1')
	! 	!call to_history("label3",'iteration', 'weightsBOT1')
	! end if

	if (exist_file('drlse_term1')) then
		call to_history("n1",nz, 'drlse_term1')
		call to_history("n2",nx, 'drlse_term1')
		!call to_history("n3",niter, 'drlse_term1')
		call to_history("d1",dz, 'drlse_term1')
		call to_history("d2",dx, 'drlse_term1')
		call to_history("o1",oz, 'drlse_term1')
		call to_history("o2",ox, 'drlse_term1')
		call to_history("label1",'z [km]', 'drlse_term1')
		call to_history("label2",'x [km]', 'drlse_term1')
		!call to_history("label3",'iteration', 'drlse_term1')
	end if

	if (exist_file('s1')) then
		call to_history("n1",nz, 's1')
		call to_history("n2",nx, 's1')
		!call to_history("n3",niter, 's1')
		call to_history("d1",dz, 's1')
		call to_history("d2",dx, 's1')
		call to_history("o1",oz, 's1')
		call to_history("o2",ox, 's1')
		call to_history("label1",'z [km]', 's1')
		call to_history("label2",'x [km]', 's1')
		!call to_history("label3",'iteration', 's1')
	end if



	if (exist_file('drlse_term2')) then
		call to_history("n1",nz, 'drlse_term2')
		call to_history("n2",nx, 'drlse_term2')
		!call to_history("n3",niter, 'drlse_term2')
		call to_history("d1",dz, 'drlse_term2')
		call to_history("d2",dx, 'drlse_term2')
		call to_history("o1",oz, 'drlse_term2')
		call to_history("o2",ox, 'drlse_term2')
		call to_history("label1",'z [km]', 'drlse_term2')
		call to_history("label2",'x [km]', 'drlse_term2')
		!call to_history("label3",'iteration', 'drlse_term2')
	end if



	if (exist_file('s2')) then
		call to_history("n1",nz, 's2')
		call to_history("n2",nx, 's2')
		!call to_history("n3",niter, 's2')
		call to_history("d1",dz, 's2')
		call to_history("d2",dx, 's2')
		call to_history("o1",oz, 's2')
		call to_history("o2",ox, 's2')
		call to_history("label1",'z [km]', 's2')
		call to_history("label2",'x [km]', 's2')
		!call to_history("label3",'iteration', 's2')
	end if



	if (exist_file('scaling')) then
		call to_history("n1",nz, 'scaling')
		call to_history("n2",nx, 'scaling')
		!call to_history("n3",niter, 'scaling')
		call to_history("d1",dz, 'scaling')
		call to_history("d2",dx, 'scaling')
		call to_history("o1",oz, 'scaling')
		call to_history("o2",ox, 'scaling')
		call to_history("label1",'z [km]', 'scaling')
		call to_history("label2",'x [km]', 'scaling')
		!call to_history("label3",'iteration', 'scaling')
	end if

end subroutine





subroutine outfiles_serial2()
	integer		:: nz, nx
	real 		:: dz, oz, dx, ox

	!----------------------------------------------------------------------------------------------
	call from_param("n1", nz)
	call from_param("n2", nx)
	call from_param("o1", oz)
	call from_param("o2", ox)
	call from_param("d1", dz)
	call from_param("d2", dx)

! write(0,*) " GOT INSIDE THIS SUBROUTINE OUTFILES_SERIAL2   " , NL_niter
	!----------------------------------------------------------------------------------------------

	if (exist_file('phi_grad1')) then
   		call to_history("n1",nz, 'phi_grad1')
   		call to_history("n2",nx, 'phi_grad1')
		!call to_history("n3",niter, 'phi_grad1')
		call to_history("d1",dz, 'phi_grad1')
		call to_history("d2",dx, 'phi_grad1')
		call to_history("o1",oz, 'phi_grad1')
		call to_history("o2",ox, 'phi_grad1')
		call to_history("label1",'z [km]', 'phi_grad1')
		call to_history("label2",'x [km]', 'phi_grad1')
		!call to_history("label3",'iteration', 'phi_grad1')
	end if

	if (exist_file('phi_grad2')) then
		call to_history("n1",nz, 'phi_grad2')
		call to_history("n2",nx, 'phi_grad2')
		!call to_history("n3",niter, 'phi_grad2')
		call to_history("d1",dz, 'phi_grad2')
		call to_history("d2",dx, 'phi_grad2')
		call to_history("o1",oz, 'phi_grad2')
		call to_history("o2",ox, 'phi_grad2')
		call to_history("label1",'z [km]', 'phi_grad2')
		call to_history("label2",'x [km]', 'phi_grad2')
		!call to_history("label3",'iteration', 'phi_grad2')
	end if

	if (exist_file('tomo_grad')) then
		call to_history("n1",nz, 'tomo_grad')
		call to_history("n2",nx, 'tomo_grad')
		!call to_history("n3",niter, 'tomo_grad')
		call to_history("d1",dz, 'tomo_grad')
		call to_history("d2",dx, 'tomo_grad')
		call to_history("o1",oz, 'tomo_grad')
		call to_history("o2",ox, 'tomo_grad')
		call to_history("label1",'z [km]', 'tomo_grad')
		call to_history("label2",'x [km]', 'tomo_grad')
		!call to_history("label3",'iteration', 'tomo_grad')
	end if




	if (exist_file('weight2')) then
		call to_history("n1",nz, 'weight2')
		call to_history("n2",nx, 'weight2')
		!call to_history("n3",niter, 'weight2')
		call to_history("d1",dz, 'weight2')
		call to_history("d2",dx, 'weight2')
		call to_history("o1",oz, 'weight2')
		call to_history("o2",ox, 'weight2')
		call to_history("label1",'z [km]', 'weight2')
		call to_history("label2",'x [km]', 'weight2')
		!call to_history("label3",'iteration', 'weight2')
	end if


end subroutine







subroutine outfiles_maxbeta()
	integer		:: nz, nx
	real 		:: dz, oz, dx, ox

	!----------------------------------------------------------------------------------------------
	call from_param("n1", nz)
	call from_param("n2", nx)
	call from_param("o1", oz)
	call from_param("o2", ox)
	call from_param("d1", dz)
	call from_param("d2", dx)

! write(0,*) " GOT INSIDE THIS SUBROUTINE OUTFILES_SERIAL2   "
	!----------------------------------------------------------------------------------------------



	if (exist_file('maxbeta')) then
		call to_history("n1",1					, 'maxbeta')
		call to_history("d1",1.0				, 'maxbeta')
		call to_history("o1",0.0				, 'maxbeta')
		call to_history("label1",'iteration'	, 'maxbeta')
	end if



	if (exist_file('tomo_grad_out')) then
		call to_history("n1",nz, 'tomo_grad_out')
		call to_history("n2",nx, 'tomo_grad_out')
		!call to_history("n3",niter, 'tomo_grad_out')
		call to_history("d1",dz, 'tomo_grad_out')
		call to_history("d2",dx, 'tomo_grad_out')
		call to_history("o1",oz, 'tomo_grad_out')
		call to_history("o2",ox, 'tomo_grad_out')
		call to_history("label1",'z [km]', 'tomo_grad_out')
		call to_history("label2",'x [km]', 'tomo_grad_out')
		!call to_history("label3",'iteration', 'tomo_grad_out')
	end if



	if (exist_file('phi_grad1_out')) then
		call to_history("n1",nz, 'phi_grad1_out')
		call to_history("n2",nx, 'phi_grad1_out')
		!call to_history("n3",niter, 'phi_grad1_out')
		call to_history("d1",dz, 'phi_grad1_out')
		call to_history("d2",dx, 'phi_grad1_out')
		call to_history("o1",oz, 'phi_grad1_out')
		call to_history("o2",ox, 'phi_grad1_out')
		call to_history("label1",'z [km]', 'phi_grad1_out')
		call to_history("label2",'x [km]', 'phi_grad1_out')
		!call to_history("label3",'iteration', 'phi_grad1_out')
	end if



	if (exist_file('phi_grad2_out')) then
		call to_history("n1",nz, 'phi_grad2_out')
		call to_history("n2",nx, 'phi_grad2_out')
		!call to_history("n3",niter, 'phi_grad2_out')
		call to_history("d1",dz, 'phi_grad2_out')
		call to_history("d2",dx, 'phi_grad2_out')
		call to_history("o1",oz, 'phi_grad2_out')
		call to_history("o2",ox, 'phi_grad2_out')
		call to_history("label1",'z [km]', 'phi_grad2_out')
		call to_history("label2",'x [km]', 'phi_grad2_out')
		!call to_history("label3",'iteration', 'phi_grad2_out')
	end if


end subroutine




end module
