#!/bin/tcsh
### first is the common part
###   each node is dual CPU with Quad core Nehalem
#PBS -N test_bte-2
#PBS -l nodes=1:ppn=8
#PBS -q default
#PBS -V
#PBS -m e
#PBS -W x="PARTITION:sw121"
#PBS -j oe
#PBS -e /data/sep/zyang03/for/sep/batch_task/wrk/test_bte-2.log
#PBS -o /data/sep/zyang03/for/sep/batch_task/wrk/test_bte-2.log
#PBS -d /data/sep/zyang03/for/sep/batch_task/wrk
#

#
cd $PBS_O_WORKDIR
#

echo WORKDIR is: $PBS_O_WORKDIR
sleep 5
echo NodeFile is: $PBS_NODEFILE
echo hostname is: $HOSTNAME

set TMPDIR=/tmp
set HOSTFILE=hostfile_${PBS_JOBID}
echo hostfile is: ${HOSTFILE}
cat ${PBS_NODEFILE} | sort | uniq > ${HOSTFILE}
#set MIG_PAR_WAZ3D=" pdip=65 oper=ssfpi nvrf=4 nws=32 nxpad_beg=40 nxpad_end=40 nypad_beg=30 nypad_end=30 ntpx=25 ntpy=25 memchk=n "
#image_zmin=10 image_zmax= "



# Final clean up, remove the files at tmp folder.
find /tmp/ -maxdepth 1 -type f -user zyang03 -exec rm {} \;

Cp /data/sep/zyang03/for/sep/batch_task/test2.H /data/sep/zyang03/for/sep/batch_task/wrk/testfile-2-0.tmp out=stdout 
sleep 1

# Final clean up, remove the files at tmp folder.
find /tmp/ -maxdepth 1 -type f -user zyang03 -exec rm {} \;
