program main
  use sep
  implicit none
  
  integer :: n1, n2, n3
  real    :: d1, d2, d3
  real    :: o1, o2, o3
  logical :: axis1, axis2, axis3, km
  real    :: fctr

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  call from_param("axis1", axis1, .false.)
  call from_param("axis2", axis2, .false.)
  call from_param("axis3", axis3, .false.)

  call from_param("km", km, .true.)

  call auxinout("header")

  if (km) then
     fctr = 0.3048*0.001
  else
     fctr = 0.3048
  end if

  if (axis1) then
     call from_aux("header", "d1", d1); d1 = d1*fctr; call auxputch("d1", "r", d1, "header")
     call from_aux("header", "o1", o1); o1 = o1*fctr; call auxputch("o1", "r", o1, "header")
  end if

  if (axis2) then
     call from_aux("header", "d2", d2); d2 = d2*fctr; call auxputch("d2", "r", d2, "header")
     call from_aux("header", "o2", o2); o2 = o2*fctr; call auxputch("o2", "r", o2, "header")
  end if

  if (axis3) then
     call from_aux("header", "d3", d3); d3 = d3*fctr; call auxputch("d3", "r", d3, "header")
     call from_aux("header", "o3", o3); o3 = o3*fctr; call auxputch("o3", "r", o3, "header")
  end if


end program
