
inline void create_cpy_one2all(char *cpy_file, char *tmpdir, char *fnone, char *fnall){
  strcpy(cpy_file, "Cp "       ); strcat(cpy_file, fnone ); strcat(cpy_file, " "); strcat(cpy_file, fnall);
  strcat(cpy_file, " datapath="); strcat(cpy_file, tmpdir);
}

inline void create_cpy_all2one(char *cpy_file, char *fnone, char *fnall){
  strcpy(cpy_file, "Cp "); strcat(cpy_file, fnall); strcat(cpy_file, " "); strcat(cpy_file, fnone);
}

inline void create_cmd_imagcube(char *cmd_imagcube, char *bindir, char *tmpdir, char *fncsou, char *fncrec, char *fnbvel, char *fnbimg, char *par_imagcube){
  strcpy(cmd_imagcube, bindir      ); strcat(cmd_imagcube, "imagcube-mpi.x"); strcat(cmd_imagcube, " csou="); strcat(cmd_imagcube, fncsou      );
  strcat(cmd_imagcube, " crec="    ); strcat(cmd_imagcube, fncrec          ); strcat(cmd_imagcube, " bvel="); strcat(cmd_imagcube, fnbvel      );
  strcat(cmd_imagcube, " bimg="    ); strcat(cmd_imagcube, fnbimg          ); strcat(cmd_imagcube, " "     ); strcat(cmd_imagcube, par_imagcube);
  strcat(cmd_imagcube, " datapath="); strcat(cmd_imagcube, tmpdir          );
}

inline void create_cmd_residual(char *cmd_residual, char *bindir, char *tmpdir, char *fnbimg, char *fnfobj, char *fnimsk, char *par_residual){
  strcpy(cmd_residual, bindir      ); strcat(cmd_residual, "residual-mpi.x"); strcat(cmd_residual, " bimg="    ); strcat(cmd_residual, fnbimg);
  strcat(cmd_residual, " fobj="    ); strcat(cmd_residual, fnfobj          ); strcat(cmd_residual, " imsk="    ); strcat(cmd_residual, fnimsk);
  strcat(cmd_residual, " "         ); strcat(cmd_residual, par_residual    ); strcat(cmd_residual, " datapath="); strcat(cmd_residual, tmpdir);
}

inline void create_cmd_gradient(char *cmd_gradient, char *bindir, char *tmpdir, char *fncsou, char *fncrec, char *fnbvel, char *fndimg, char *fndvel, char *par_gradient) {
  strcpy(cmd_gradient, bindir  ); strcat(cmd_gradient, "gradient-mpi.x"); strcat(cmd_gradient, " csou="    ); strcat(cmd_gradient, fncsou);
  strcat(cmd_gradient, " crec="); strcat(cmd_gradient, fncrec          ); strcat(cmd_gradient, " bvel="    ); strcat(cmd_gradient, fnbvel);
  strcat(cmd_gradient, " dimg="); strcat(cmd_gradient, fndimg          ); strcat(cmd_gradient, " dvel="    ); strcat(cmd_gradient, fndvel);
  strcat(cmd_gradient, " "     ); strcat(cmd_gradient, par_gradient    ); strcat(cmd_gradient, " datapath="); strcat(cmd_gradient, tmpdir);
}

inline void create_cmd_gradprcs(char *cmd_gradprcs, char *bindir, char *tmpdir, char *fngrdo, char *fngmsk, char *fnbimg, char *par_gradprcs){
  strcpy(cmd_gradprcs, bindir      ); strcat(cmd_gradprcs, "gradprcs-mpi.x"); strcat(cmd_gradprcs, " grdo="); strcat(cmd_gradprcs, fngrdo);
  strcat(cmd_gradprcs, " gmsk="    ); strcat(cmd_gradprcs, fngmsk          ); strcat(cmd_gradprcs, " bimg="); strcat(cmd_gradprcs, fnbimg);
  strcat(cmd_gradprcs, " "         ); strcat(cmd_gradprcs, par_gradprcs    );
  strcat(cmd_gradprcs, " datapath="); strcat(cmd_gradprcs, tmpdir          );
}

inline void create_cmd_srchdrct(char *cmd_srchdrct, char *bindir, char *tmpdir, char *fnsrch, char *fngrdo, char *fngrdp, char *method){
  strcpy(cmd_srchdrct, bindir  ); strcat(cmd_srchdrct, "srchdrct-mpi.x"); strcat(cmd_srchdrct, " srch="); strcat(cmd_srchdrct, fnsrch);
  strcat(cmd_srchdrct, " grdo="); strcat(cmd_srchdrct, fngrdo          ); strcat(cmd_srchdrct, " grdp="); strcat(cmd_srchdrct, fngrdp);
  strcat(cmd_srchdrct, method  ); strcat(cmd_srchdrct, " datapath="    ); strcat(cmd_srchdrct, tmpdir  );
}

inline void create_cmd_initfile(char *cmd_initfile, char *bindir, char *tmpdir, char *fnmmov, char *fnfmov, char *par_initfile){
  strcpy(cmd_initfile, bindir      ); strcat(cmd_initfile, "initfile-mpi.x"); strcat(cmd_initfile, " mmov="); strcat(cmd_initfile, fnmmov      );
  strcat(cmd_initfile, " fmov="    ); strcat(cmd_initfile, fnfmov          ); strcat(cmd_initfile, " "     ); strcat(cmd_initfile, par_initfile);
  strcat(cmd_initfile, " datapath="); strcat(cmd_initfile, tmpdir          );
}

inline void create_cmd_bornmodl(char *cmd_bornmodl, char *bindir, char *tmpdir, char *fncsou, char *fncrec, char *fnbvel, char *fnbimg, char *par_bornmodl){
  strcpy(cmd_bornmodl, bindir      ); strcat(cmd_bornmodl, "bwi-wem3d.x"); strcat(cmd_bornmodl, " csou="); strcat(cmd_bornmodl, fncsou      );
  strcat(cmd_bornmodl, " crec="    ); strcat(cmd_bornmodl, fncrec       ); strcat(cmd_bornmodl, " bvel="); strcat(cmd_bornmodl, fnbvel      );
  strcat(cmd_bornmodl, " bimg="    ); strcat(cmd_bornmodl, fnbimg       ); strcat(cmd_bornmodl, " "     ); strcat(cmd_bornmodl, par_bornmodl);
  strcat(cmd_bornmodl, " datapath="); strcat(cmd_bornmodl, tmpdir       );
}

