
! program RTM
! 	use sep
! 	use mem_mod
! 	use fbi_mod
! 	use initialize
! 	implicit none

! 	!===========================================================================
! 	!	Allocate and Initialize
! 	!---------------------------------------------------------------------------
! 	integer									:: isou,rec_dx,rec_ox,sou_dx,sou_ox,nz,nx,nt,bc1,bc2,bc3,bc4,wfld_j,sou_nx,rec_nx,rec_z,niter, nh
! 	real 									:: dz,dx,dt,oz,ox,ot,tstep,vstep
! 	real, dimension(:,:,:), allocatable		:: residual, vel_grad_out
! 	real, dimension(:,:), allocatable		:: vel_in, residual_shot
! 	!===========================================================================

! 	call init_rtm(nz,nx,nt,nh,dz,dx,dt,oz,ox,ot,bc1,bc2,bc3,bc4,wfld_j,sou_nx,sou_dx,sou_ox,rec_nx,rec_dx,rec_ox,rec_z,tstep,vstep,niter)

! 	call mem_alloc3d(residual, nt, rec_nx, sou_nx)
! 	call mem_alloc2d(residual_shot, nt, rec_nx)
! 	call mem_alloc3d(vel_grad_out, nz, nx, (2*nh+1))
! 	call mem_alloc2d(vel_in, nz, nx)

! 	call sep_init()

! 	call sep_read(vel_in,"velmod")
! 	call sep_read(residual,"residualin")
! 	call model_update(vel_in)

! 	call from_param("isou", isou)

! write(0,*) "Inside the RTM program"
! 	!---------------------------------------------------------------------------
! 	residual_shot = residual(:,:,isou)
! 	! Linear operator: full nonlinear data => model perturbation
! 	call L_lop2(.true., .false., vel_grad_out, residual_shot, isou) 

! write(0,*) "Inside the RTM program: Finished L_lop2"

! 	if (exist_file('tomograd_ns')) then
! 		call to_history("n1",nz, 'tomograd_ns')
! 		call to_history("n2",nx, 'tomograd_ns')
! 		call to_history("n3",(2*nh+1), 'tomograd_ns')
! 		call to_history("n4",1,  'tomograd_ns')
! 		call to_history("d1",dz, 'tomograd_ns')
! 		call to_history("d2",dx, 'tomograd_ns')
! 		call to_history("d3",dx, 'tomograd_ns')
! 		call to_history("o1",oz, 'tomograd_ns')
! 		call to_history("o2",ox, 'tomograd_ns')
! 		call to_history("o3",0.0, 'tomograd_ns')
! 		call to_history("o4",1.0, 'tomograd_ns')
! 		call to_history("label1",'z [km]', 'tomograd_ns')
! 		call to_history("label2",'x [km]', 'tomograd_ns')
! 		call to_history("label3",'hx', 'tomograd_ns')
! 		call to_history("label4",'shot', 'tomograd_ns')
! 		call sep_write(vel_grad_out,'tomograd_ns')
! 	end if

! write(0,*) "Inside the RTM program: tomograd_ns writen out"

! end program



