import os, sys
from optparse import OptionParser

usage = 'usage: %prog [options] arg1 arg2'

parser = OptionParser(usage=usage)

parser.add_option('--result', dest='result', type='string', default='RESULT.H', help='Results to be stacked')
parser.add_option('--extension', dest='extension', type='string', default='.shot', help='Extension to be added on')
parser.add_option('--index_beg', dest='index_beg', type='int', default=1, help='Shot starting index')
parser.add_option('--index_end', dest='index_end', type='int', default=1, help='Shot ending index')

(options, args) = parser.parse_args()

RESULT = options.result
RESDIR = '.'

BSHOT = options.index_beg
ESHOT = options.index_end + 1

root, ext  = os.path.splitext(RESULT)

RESULT_TOTAL = root+ext
RESULT_TOTAL = os.path.join(RESDIR, RESULT_TOTAL)

RESULT_SPLIT = root+options.extension+'%d'+ext
RESULT_SPLIT = os.path.join(RESDIR, RESULT_SPLIT)

RESULT_JUNKS = root+'.junk'+ext
RESULT_JUNKS = os.path.join(RESDIR, RESULT_JUNKS)

cmd = 'Add ' + (RESULT_SPLIT % BSHOT) + ' scale=0 '+'> '+ RESULT_JUNKS
print cmd
os.system(cmd)
for ishot in range(BSHOT, ESHOT):
	cmd1 = 'Add ' + RESULT_JUNKS + ' ' + (RESULT_SPLIT % ishot) + ' > ' + RESULT_TOTAL
        cmd2 = 'Cp '  + RESULT_TOTAL + ' ' + RESULT_JUNKS
	print cmd1
        os.system(cmd1)
	print cmd2
        os.system(cmd2)

cmd = 'Rm ' + RESULT_JUNKS
print cmd
os.system(cmd)
