program main
  use sep
  implicit none


  integer                         :: nx, ny, nz
  real, dimension(:), allocatable :: dip
  real                            :: PI

  PI = 3.14159265359

  call initpar()

  call from_history("n1", nx)
  call from_history("n2", ny)
  call from_history("n3", nz)

  allocate(dip(nx*ny*nz)) 

  call sep_read(dip)

  dip = tan(dip*PI/180.)
   
  call sep_write(dip)

end program
