program main
  use sep
  implicit none

  integer :: n1, n2, n3, i1, i2, i3
  real, dimension(:,:,:), allocatable :: data
  real :: xmin, xmax, dx

  call initpar()

  call from_history("n1", n1)
  call from_history("n2", n2)
  call from_history("n3", n3)

  call from_param("minval", xmin, -1.)
  call from_param("maxval", xmax, 1. )

  allocate(data(n1,n2,n3))

  call random_seed()
  do i3=1, n3
  do i2=1, n2
  do i1=1, n1
     call random_number(data(i1,i2,i3))
  end do
  end do
  end do
 
  data = data*(xmax-xmin) + xmin

  call sep_write(data)

end program
