program main
  use bwi_trismt_mod
  use sep
  implicit none

  integer :: nx, ny, nz, nrepeat, irepeat, stat
  real    :: ox, oy, oz
  real    :: dx, dy, dz, x, z
  integer :: ix, iz, jx, jz
  real, dimension(:,:,:), allocatable :: vmod, temp

  call initpar()

  call from_history("n1", nz); call from_history("d1", dz); call from_history("o1", oz)
  call from_history("n2", nx); call from_history("d2", dx); call from_history("o2", ox)


  allocate(vmod(nz,nx,1),temp(nz,nx,1))

  call sep_read(vmod)

  temp = vmod

  nrepeat = 20

  jz = 1.5+(15000-oz)/dz
  jx = 1.5+(33000-ox)/dx
  do iz=jz+1, nz
     z = oz+(iz-1)*dz
     do ix=1, nx
        x = ox+(ix-1)*dx
        if (x<90000 .and. vmod(iz,ix,1)<14900) then
           !vmod(iz,ix) = vmod(iz,jx)
           vmod(iz,ix,1) = 7600+0.1*z
        end if
     end do
  end do

  do iz=1, nz
  do ix=1, nx
     if (vmod(iz,ix,1)==14900) then
           vmod(iz,ix,1) = vmod(iz,1,1)
     end if
  end do
  end do

  do irepeat=1, nrepeat
     stat = bwi_trismt_oper(vmod,20,1,0)
  end do

  jz = 1.5+(15000-oz)/dz

  vmod(1:jz,:,1) = temp(1:jz,:,1)

  where (temp==14900)
    vmod = temp 
  end where

  call sep_write(vmod)


end program
