program main
  use sep
  implicit none


  integer :: nt, nh, nx, ix, ih, jhb, jhe
  real :: rms, mean, var 
  real, dimension(:,:), allocatable :: data

  call initpar()

  call from_history("n1", nt)
  call from_history("n2", nh)
  call from_history("n3", nx)


  allocate(data(nt,nh))

  do ix=1, nx
     call sep_read(data)

! write(0,*)maxval(abs(data)), ix

     do ih=1, nh
        rms = sqrt(sum(data(:,ih)**2)/nt)
!        if (rms>1.e+5 .or. ISNAN(rms)) then
!           jhb = min(ih+8, nh)
!           jhe = max(ih-8, 1 )
!           data(:,jhb:jhe) = 0.
!        end if

        if (1./rms>1.e+5 .or. ISNAN(rms)) then
           data(:,ih-12:) = 0.
        end if
     end do

     data(:,nh-12:nh) = 0.

     call sep_write(data)
  end do


end program
