
inline void fio_imag(float *imag, int nhx, int nhy, int nx, int ny, int nz, int iz, char *filetag, int flag) {
  int n_cube[5], j_wind[5], n_wind[5], f_wind[5];
  int n_dim_cube;
  
  n_dim_cube = 5;
  n_cube[0] = nhx; n_cube[1] = nhy; n_cube[2] = nx; n_cube[3] = ny; n_cube[4] = nz  ;
  j_wind[0] = 1  ; j_wind[1] = 1  ; j_wind[2] = 1 ; j_wind[3] = 1 ; j_wind[4] = 1   ;
  n_wind[0] = nhx; n_wind[1] = nhy; n_wind[2] = nx; n_wind[3] = ny; n_wind[4] = 1   ;
  f_wind[0] = 0  ; f_wind[1] = 0  ; f_wind[2] = 0 ; f_wind[3] = 0 ; f_wind[4] = iz-1;
  
  
  
  if (flag==0) {
     sreed_window(filetag,&n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,imag);
  } 
  else if (flag==1) {
     srite_window(filetag,&n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,imag);
  }
}

////////////////////// Other auxiliary functions ///////////////////
typedef struct {
  int n;
  float d, o;
  char l[20];
} axis;

void inline hinaxis(char *filename, axis *ax, int ndim){
  if (0!=sep_get_data_axis_par(filename,&ndim,&(ax->n),&(ax->o),&(ax->d),&(ax->l)))
                 seperr("trouble reading axis %d to tag %s\n",ndim,filename);
}

void inline houaxis(char *filename, axis *ax, int ndim){
  if (0!=sep_put_data_axis_par(filename,&ndim,&(ax->n),&(ax->o),&(ax->d),&(ax->l)))
                 seperr("trouble writing axis %d to tag %s\n",ndim,filename);
}

